<?php

declare(strict_types=1);

namespace Drupal\jsonapi_section_components\Hook;

use Drupal\Core\Hook\Attribute\Hook;
use Drupal\jsonapi_section_components\Plugin\Block\FieldBlock;
use Drupal\jsonapi_section_components\Plugin\Block\InlineBlock;
use Drupal\jsonapi_section_components\Plugin\Block\ViewsBlock;

/**
 * Hook implementations for the node module.
 */
class BlockAlter {

  /**
   * Implements hook_block_alter().
   *
   * Customizes the some plugin block classes.
   */
  #[Hook('block_alter')]
  public function alterBlock(array &$definitions) {
    foreach ($definitions as $id => $definition) {
      if (str_starts_with($id, 'inline_block:')) {
        $definitions[$id]['class'] = InlineBlock::class;
      }
    }

    foreach ($definitions as $id => $definition) {
      if (str_starts_with($id, 'field_block:')) {
        $definitions[$id]['class'] = FieldBlock::class;
      }
    }

    foreach ($definitions as $id => $definition) {
      if (str_starts_with($id, 'views_block:')) {
        $definitions[$id]['class'] = ViewsBlock::class;
      }
    }
  }

}
