<?php

namespace Drupal\jsonapi_section_components\Plugin\Block;

use Drupal\Core\Entity\ContentEntityBase;
use Drupal\layout_builder\Plugin\Block\InlineBlock as OriginalPluginBlock;
use Drupal\layout_builder\SectionComponent;
use Drupal\Core\Entity\EntityBase;

/**
 * InlineBlock class.
 *
 * This class extends the original InlineBlock class and implements
 * SectionComponentBlockInterface.
 *
 * @package Drupal\jsonapi_section_components\Plugin\Block
 */
class InlineBlock extends OriginalPluginBlock implements SectionComponentBlockInterface {

  /**
   * {@inheritdoc}
   */
  public function processSectionComponent(SectionComponent $section_component): array {
    $config = $section_component->get('configuration');
    unset($config['block_serialized']);
    return $config;
  }

  /**
   * {@inheritdoc}
   */
  public function getResponseEntity(SectionComponent $section_component, EntityBase $content): EntityBase {
    $config = $section_component->get('configuration');
    if (!empty($config['block_serialized'])) {
      $block = \unserialize($config['block_serialized']);
      if ($block instanceof ContentEntityBase) {
        $block->mergeCacheMaxAge(0);
      }
      return $block;
    }
    if (!empty($config['uuid'])) {
      $blocks = $this->entityTypeManager->getStorage('block_content')->loadByProperties(['uuid' => $config['uuid']]);
      if (!empty($blocks)) {
        $block = reset($blocks);
        if ($block instanceof ContentEntityBase) {
          $block->mergeCacheMaxAge(0);
        }
        return $block;
      }
    }
    return $content;
  }

}
